--- net/minecraft/src/GuiChest.java
+++ net/minecraft/src/GuiChest.java
@@ -8,6 +8,7 @@
 	private int inventoryRows = 0;
 
 	public GuiChest(IInventory var1, IInventory var2) {
+		super(new ContainerChest(var1, var2));
 		this.upperChestInventory = var1;
 		this.lowerChestInventory = var2;
 		this.allowUserInput = false;
@@ -15,25 +16,6 @@
 		int var4 = var3 - 108;
 		this.inventoryRows = var2.getSizeInventory() / 9;
 		this.ySize = var4 + this.inventoryRows * 18;
-		int var5 = (this.inventoryRows - 4) * 18;
-
-		int var6;
-		int var7;
-		for(var6 = 0; var6 < this.inventoryRows; ++var6) {
-			for(var7 = 0; var7 < 9; ++var7) {
-				this.inventorySlots.add(new SlotInventory(this, var2, var7 + var6 * 9, 8 + var7 * 18, 18 + var6 * 18));
-			}
-		}
-
-		for(var6 = 0; var6 < 3; ++var6) {
-			for(var7 = 0; var7 < 9; ++var7) {
-				this.inventorySlots.add(new SlotInventory(this, var1, var7 + (var6 + 1) * 9, 8 + var7 * 18, 103 + var6 * 18 + var5));
-			}
-		}
-
-		for(var6 = 0; var6 < 9; ++var6) {
-			this.inventorySlots.add(new SlotInventory(this, var1, var6, 8 + var6 * 18, 161 + var5));
-		}
 
 	}
 
--- net/minecraft/src/Packet15Place.java
+++ net/minecraft/src/Packet15Place.java
@@ -5,37 +5,52 @@
 import java.io.IOException;
 
 public class Packet15Place extends Packet {
-	public int id;
 	public int xPosition;
 	public int yPosition;
 	public int zPosition;
 	public int direction;
+	public ItemStack itemStack;
 
 	public Packet15Place() {
 	}
 
-	public Packet15Place(int var1, int var2, int var3, int var4, int var5) {
-		this.id = var1;
-		this.xPosition = var2;
-		this.yPosition = var3;
-		this.zPosition = var4;
-		this.direction = var5;
+	public Packet15Place(int var1, int var2, int var3, int var4, ItemStack var5) {
+		this.xPosition = var1;
+		this.yPosition = var2;
+		this.zPosition = var3;
+		this.direction = var4;
+		this.itemStack = var5;
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.id = var1.readShort();
 		this.xPosition = var1.readInt();
 		this.yPosition = var1.read();
 		this.zPosition = var1.readInt();
 		this.direction = var1.read();
+		short var2 = var1.readShort();
+		if(var2 >= 0) {
+			byte var3 = var1.readByte();
+			short var4 = var1.readShort();
+			this.itemStack = new ItemStack(var2, var3, var4);
+		} else {
+			this.itemStack = null;
+		}
+
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeShort(this.id);
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.write(this.yPosition);
 		var1.writeInt(this.zPosition);
 		var1.write(this.direction);
+		if(this.itemStack == null) {
+			var1.writeShort(-1);
+		} else {
+			var1.writeShort(this.itemStack.itemID);
+			var1.writeByte(this.itemStack.stackSize);
+			var1.writeShort(this.itemStack.getItemDamage());
+		}
+
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -43,6 +58,6 @@
 	}
 
 	public int getPacketSize() {
-		return 12;
+		return 15;
 	}
 }
--- net/minecraft/src/PlayerController.java
+++ net/minecraft/src/PlayerController.java
@@ -43,6 +43,21 @@
 	public float getBlockReachDistance() {
 		return 5.0F;
 	}
+	
+	public boolean sendUseItem(EntityPlayer var1, World var2, ItemStack var3) {
+		int var4 = var3.stackSize;
+		ItemStack var5 = var3.useItemRightClick(var2, var1);
+		if(var5 != var3 || var5 != null && var5.stackSize != var4) {
+			var1.inventory.mainInventory[var1.inventory.currentItem] = var5;
+			if(var5.stackSize == 0) {
+				var1.inventory.mainInventory[var1.inventory.currentItem] = null;
+			}
+
+			return true;
+		} else {
+			return false;
+		}
+	}
 
 	public void flipPlayer(EntityPlayer var1) {
 	}
@@ -56,13 +71,30 @@
 
 	public void onRespawn(EntityPlayer var1) {
 	}
-
-	public boolean onPlayerRightClick(EntityPlayer var1, World var2, ItemStack var3, int var4, int var5, int var6, int var7) {
+	
+	public boolean sendPlaceBlock(EntityPlayer var1, World var2, ItemStack var3, int var4, int var5, int var6, int var7) {
 		int var8 = var2.getBlockId(var4, var5, var6);
 		return var8 > 0 && Block.blocksList[var8].blockActivated(var2, var4, var5, var6, var1) ? true : (var3 == null ? false : var3.useItem(var1, var2, var4, var5, var6, var7));
 	}
 
 	public EntityPlayer createPlayer(World var1) {
 		return new EntityPlayerSP(this.mc, var1, this.mc.session);
+	}
+	
+	public void interactWithEntity(EntityPlayer var1, Entity var2) {
+		var1.useCurrentItemOnEntity(var2);
+	}
+
+	public void attackEntity(EntityPlayer var1, Entity var2) {
+		var1.attackTargetEntityWithCurrentItem(var2);
+	}
+
+	public ItemStack func_27174_a(int var1, int var2, int var3, boolean var4, EntityPlayer var5) {
+		return var5.craftingInventory.func_27280_a(var2, var3, var4, var5);
+	}
+
+	public void func_20086_a(int var1, EntityPlayer var2) {
+		var2.craftingInventory.onCraftGuiClosed(var2);
+		var2.craftingInventory = var2.inventorySlots;
 	}
 }
--- net/minecraft/src/ItemSaddle.java
+++ net/minecraft/src/ItemSaddle.java
@@ -10,8 +10,8 @@
 	public void saddleEntity(ItemStack var1, EntityLiving var2) {
 		if(var2 instanceof EntityPig) {
 			EntityPig var3 = (EntityPig)var2;
-			if(!var3.saddled) {
-				var3.saddled = true;
+			if(!var3.getSaddled()) {
+				var3.setSaddled(true);
 				--var1.stackSize;
 			}
 		}
--- net/minecraft/src/ItemSword.java
+++ net/minecraft/src/ItemSword.java
@@ -18,12 +18,12 @@
 		return 1.5F;
 	}
 
-	public void hitEntity(ItemStack var1, EntityLiving var2) {
-		var1.damageItem(1);
+	public void hitEntity(ItemStack var1, EntityLiving var2, EntityLiving var3) {
+		var1.damageItem(1, var3);
 	}
 
-	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5) {
-		var1.damageItem(2);
+	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5, EntityLiving var6) {
+		var1.damageItem(2, var6);
 	}
 
 	public int getDamageVsEntity(Entity var1) {
--- net/minecraft/src/TileEntityChest.java
+++ net/minecraft/src/TileEntityChest.java
@@ -80,4 +80,8 @@
 	public int getInventoryStackLimit() {
 		return 64;
 	}
+	
+	public boolean canInteractWith(EntityPlayer var1) {
+		return this.worldObj.getBlockTileEntity(this.xCoord, this.yCoord, this.zCoord) != this ? false : var1.getDistanceSq((double)this.xCoord + 0.5D, (double)this.yCoord + 0.5D, (double)this.zCoord + 0.5D) <= 64.0D;
+	}
 }
--- net/minecraft/src/EntitySlime.java
+++ net/minecraft/src/EntitySlime.java
@@ -4,32 +4,40 @@
 	public float squishFactor;
 	public float prevSquishFactor;
 	private int slimeJumpDelay = 0;
-	public int size = 1;
 
 	public EntitySlime(World var1) {
 		super(var1);
 		this.texture = "/mob/slime.png";
-		this.size = 1 << this.rand.nextInt(3);
+		int var2 = 1 << this.rand.nextInt(3);
 		this.yOffset = 0.0F;
 		this.slimeJumpDelay = this.rand.nextInt(20) + 10;
-		this.setSlimeSize(this.size);
+		this.setSlimeSize(var2);
+	}
+
+	protected void entityInit() {
+		super.entityInit();
+		this.dataWatcher.addObject(16, new Byte((byte)1));
 	}
 
 	public void setSlimeSize(int var1) {
-		this.size = var1;
+		this.dataWatcher.updateObject(16, new Byte((byte)var1));
 		this.setSize(0.6F * (float)var1, 0.6F * (float)var1);
 		this.health = var1 * var1;
 		this.setPosition(this.posX, this.posY, this.posZ);
 	}
+	
+	public int getSlimeSize() {
+		return this.dataWatcher.getWatchableObjectByte(16);
+	}
 
 	public void writeEntityToNBT(NBTTagCompound var1) {
 		super.writeEntityToNBT(var1);
-		var1.setInteger("Size", this.size - 1);
+		var1.setInteger("Size", this.getSlimeSize() - 1);
 	}
 
 	public void readEntityFromNBT(NBTTagCompound var1) {
 		super.readEntityFromNBT(var1);
-		this.size = var1.getInteger("Size") + 1;
+		this.setSlimeSize(var1.getInteger("Size") + 1);
 	}
 
 	public void onUpdate() {
@@ -37,15 +45,17 @@
 		boolean var1 = this.onGround;
 		super.onUpdate();
 		if(this.onGround && !var1) {
-			for(int var2 = 0; var2 < this.size * 8; ++var2) {
+			int size = this.getSlimeSize();
+			
+			for(int var2 = 0; var2 < size * 8; ++var2) {
 				float var3 = this.rand.nextFloat() * (float)Math.PI * 2.0F;
 				float var4 = this.rand.nextFloat() * 0.5F + 0.5F;
-				float var5 = MathHelper.sin(var3) * (float)this.size * 0.5F * var4;
-				float var6 = MathHelper.cos(var3) * (float)this.size * 0.5F * var4;
+				float var5 = MathHelper.sin(var3) * (float)size * 0.5F * var4;
+				float var6 = MathHelper.cos(var3) * (float)size * 0.5F * var4;
 				this.worldObj.spawnParticle("slime", this.posX + (double)var5, this.boundingBox.minY, this.posZ + (double)var6, 0.0D, 0.0D, 0.0D);
 			}
 
-			if(this.size > 2) {
+			if(size > 2) {
 				this.worldObj.playSoundAtEntity(this, "mob.slime", this.getSoundVolume(), ((this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F) / 0.8F);
 			}
 
@@ -68,13 +78,13 @@
 			}
 
 			this.isJumping = true;
-			if(this.size > 1) {
+			if(this.getSlimeSize() > 1) {
 				this.worldObj.playSoundAtEntity(this, "mob.slime", this.getSoundVolume(), ((this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F) * 0.8F);
 			}
 
 			this.squishFactor = 1.0F;
 			this.moveStrafing = 1.0F - this.rand.nextFloat() * 2.0F;
-			this.moveForward = (float)(1 * this.size);
+			this.moveForward = (float)(1 * this.getSlimeSize());
 		} else {
 			this.isJumping = false;
 			if(this.onGround) {
@@ -85,12 +95,13 @@
 	}
 
 	public void setEntityDead() {
-		if(this.size > 1 && this.health == 0) {
+		int size = this.getSlimeSize();
+		if(!this.worldObj.multiplayerWorld && size > 1 && this.health == 0) {
 			for(int var1 = 0; var1 < 4; ++var1) {
-				float var2 = ((float)(var1 % 2) - 0.5F) * (float)this.size / 4.0F;
-				float var3 = ((float)(var1 / 2) - 0.5F) * (float)this.size / 4.0F;
+				float var2 = ((float)(var1 % 2) - 0.5F) * (float)size / 4.0F;
+				float var3 = ((float)(var1 / 2) - 0.5F) * (float)size / 4.0F;
 				EntitySlime var4 = new EntitySlime(this.worldObj);
-				var4.setSlimeSize(this.size / 2);
+				var4.setSlimeSize(size / 2);
 				var4.setLocationAndAngles(this.posX + (double)var2, this.posY + 0.5D, this.posZ + (double)var3, this.rand.nextFloat() * 360.0F, 0.0F);
 				this.worldObj.spawnEntityInWorld(var4);
 			}
@@ -100,7 +111,8 @@
 	}
 
 	public void onCollideWithPlayer(EntityPlayer var1) {
-		if(this.size > 1 && this.canEntityBeSeen(var1) && (double)this.getDistanceToEntity(var1) < 0.6D * (double)this.size && var1.attackEntityFrom(this, this.size)) {
+		int size = this.getSlimeSize();
+		if(size > 1 && this.canEntityBeSeen(var1) && (double)this.getDistanceToEntity(var1) < 0.6D * (double)size && var1.attackEntityFrom(this, size)) {
 			this.worldObj.playSoundAtEntity(this, "mob.slimeattack", 1.0F, (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
 		}
 
@@ -115,12 +127,12 @@
 	}
 
 	protected int getDropItemId() {
-		return this.size == 1 ? Item.slimeBall.shiftedIndex : 0;
+		return this.getSlimeSize() == 1 ? Item.slimeBall.shiftedIndex : 0;
 	}
 
 	public boolean getCanSpawnHere() {
 		Chunk var1 = this.worldObj.getChunkFromBlockCoords(MathHelper.floor_double(this.posX), MathHelper.floor_double(this.posY));
-		return (this.size == 1 || this.worldObj.difficultySetting > 0) && this.rand.nextInt(10) == 0 && var1.getRandomWithSeed(987234911L).nextInt(10) == 0 && this.posY < 16.0D;
+		return (this.getSlimeSize() == 1 || this.worldObj.difficultySetting > 0) && this.rand.nextInt(10) == 0 && var1.getRandomWithSeed(987234911L).nextInt(10) == 0 && this.posY < 16.0D;
 	}
 
 	protected float getSoundVolume() {
--- net/minecraft/src/ItemRenderer.java
+++ net/minecraft/src/ItemRenderer.java
@@ -10,6 +10,7 @@
 	private float equippedProgress = 0.0F;
 	private float prevEquippedProgress = 0.0F;
 	private RenderBlocks renderBlocksInstance = new RenderBlocks();
+	private int field_20099_f = -1;
 
 	public ItemRenderer(Minecraft var1) {
 		this.mc = var1;
@@ -19,7 +20,7 @@
 		GL11.glPushMatrix();
 		if(var1.itemID < 256 && RenderBlocks.renderItemIn3d(Block.blocksList[var1.itemID].getRenderType())) {
 			GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/terrain.png"));
-			this.renderBlocksInstance.renderBlockOnInventory(Block.blocksList[var1.itemID]);
+			this.renderBlocksInstance.renderBlockOnInventory(Block.blocksList[var1.itemID], var1.getItemDamageForDisplay());
 		} else {
 			if(var1.itemID < 256) {
 				GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/terrain.png"));
@@ -194,7 +195,7 @@
 	public void renderOverlays(float var1) {
 		GL11.glDisable(GL11.GL_ALPHA_TEST);
 		int var2;
-		if(this.mc.thePlayer.fire > 0) {
+		if(this.mc.thePlayer.isBurning()) {
 			var2 = this.mc.renderEngine.getTexture("/terrain.png");
 			GL11.glBindTexture(GL11.GL_TEXTURE_2D, var2);
 			this.renderFireInFirstPerson(var1);
@@ -313,8 +314,18 @@
 		this.prevEquippedProgress = this.equippedProgress;
 		EntityPlayerSP var1 = this.mc.thePlayer;
 		ItemStack var2 = var1.inventory.getCurrentItem();
+		boolean bool = this.field_20099_f == var1.inventory.currentItem && var2 == this.itemToRender;
+		if(this.itemToRender == null && var2 == null) {
+			bool = true;
+		}
+
+		if(var2 != null && this.itemToRender != null && var2 != this.itemToRender && var2.itemID == this.itemToRender.itemID && var2.getItemDamage() == this.itemToRender.getItemDamage()) {
+			this.itemToRender = var2;
+			bool = true;
+		}
+		
 		float var4 = 0.4F;
-		float var5 = var2 == this.itemToRender ? 1.0F : 0.0F;
+		float var5 = bool ? 1.0F : 0.0F;
 		float var6 = var5 - this.equippedProgress;
 		if(var6 < -var4) {
 			var6 = -var4;
@@ -327,6 +338,7 @@
 		this.equippedProgress += var6;
 		if(this.equippedProgress < 0.1F) {
 			this.itemToRender = var2;
+			this.field_20099_f = var1.inventory.currentItem;
 		}
 
 	}
--- net/minecraft/src/BlockGrass.java
+++ net/minecraft/src/BlockGrass.java
@@ -21,6 +21,9 @@
 	}
 
 	public void updateTick(World var1, int var2, int var3, int var4, Random var5) {
+		if(var1.multiplayerWorld)
+			return;
+
 		if(var1.getBlockLightValue(var2, var3 + 1, var4) < 4 && var1.getBlockMaterial(var2, var3 + 1, var4).getCanBlockGrass()) {
 			if(var5.nextInt(4) != 0) {
 				return;
--- net/minecraft/src/Packet29DestroyEntity.java
+++ net/minecraft/src/Packet29DestroyEntity.java
@@ -11,7 +11,7 @@
 		this.entityId = var1.readInt();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 	}
 
--- /dev/null
+++ net/minecraft/src/Packet63WorldParticles.java
@@ -1,0 +1,88 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet63WorldParticles extends Packet {
+
+    private String a;
+    private float b;
+    private float c;
+    private float d;
+    private float e;
+    private float f;
+    private float g;
+    private float h;
+    private int i;
+
+    public Packet63WorldParticles() {}
+
+    public void readPacketData(DataInputStream datainputstream) throws IOException {
+        this.a = readString(datainputstream, 64);
+        this.b = datainputstream.readFloat();
+        this.c = datainputstream.readFloat();
+        this.d = datainputstream.readFloat();
+        this.e = datainputstream.readFloat();
+        this.f = datainputstream.readFloat();
+        this.g = datainputstream.readFloat();
+        this.h = datainputstream.readFloat();
+        this.i = datainputstream.readInt();
+    }
+
+    public void writePacketData(DataOutputStream dataoutputstream) throws IOException {
+        writeString(this.a, dataoutputstream);
+        dataoutputstream.writeFloat(this.b);
+        dataoutputstream.writeFloat(this.c);
+        dataoutputstream.writeFloat(this.d);
+        dataoutputstream.writeFloat(this.e);
+        dataoutputstream.writeFloat(this.f);
+        dataoutputstream.writeFloat(this.g);
+        dataoutputstream.writeFloat(this.h);
+        dataoutputstream.writeInt(this.i);
+    }
+
+    public String getType() {
+       return this.a;
+    }
+
+    public double getX() {
+       return this.b;
+    }
+
+    public double getY() {
+       return this.c;
+    }
+
+    public double getZ() {
+       return this.d;
+    }
+
+    public float getVelocityX() {
+       return this.e;
+    }
+
+    public float getVelocityY() {
+       return this.f;
+    }
+
+    public float getVelocityZ() {
+       return this.g;
+    }
+
+    public float getVelocityScale() {
+       return this.h;
+    }
+
+    public int getCount() {
+       return this.i;
+    }
+
+    public void processPacket(NetHandler connection) {
+        connection.handleParticle(this);
+    }
+
+    public int getPacketSize() {
+        return 64;
+    }
+}
--- net/minecraft/src/Packet0KeepAlive.java
+++ net/minecraft/src/Packet0KeepAlive.java
@@ -2,15 +2,16 @@
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
+import java.io.IOException;
 
 public class Packet0KeepAlive extends Packet {
 	public void processPacket(NetHandler var1) {
 	}
 
-	public void readPacketData(DataInputStream var1) {
+	public void readPacketData(DataInputStream var1) throws IOException {
 	}
 
-	public void writePacket(DataOutputStream var1) {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 	}
 
 	public int getPacketSize() {
--- net/minecraft/src/Slot.java
+++ net/minecraft/src/Slot.java
@@ -1,15 +1,20 @@
 package net.minecraft.src;
 
 public class Slot {
-	public final int slotIndex;
-	public final IInventory inventory;
+	private final int slotIndex;
+	private final IInventory inventory;
+	public int slotNumber;
+	public int xDisplayPosition;
+	public int yDisplayPosition;
 
-	public Slot(IInventory var1, int var2) {
+	public Slot(IInventory var1, int var2, int var3, int var4) {
 		this.inventory = var1;
 		this.slotIndex = var2;
+		this.xDisplayPosition = var3;
+		this.yDisplayPosition = var4;
 	}
 
-	public void onPickupFromSlot() {
+	public void onPickupFromSlot(ItemStack var1) {
 		this.onSlotChanged();
 	}
 
@@ -21,16 +26,28 @@
 		return this.inventory.getStackInSlot(this.slotIndex);
 	}
 
+	public boolean getHasStack() {
+		return this.getStack() != null;
+	}
+
 	public void putStack(ItemStack var1) {
 		this.inventory.setInventorySlotContents(this.slotIndex, var1);
 		this.onSlotChanged();
 	}
 
-	public int getBackgroundIconIndex() {
-		return -1;
-	}
-
 	public void onSlotChanged() {
 		this.inventory.onInventoryChanged();
+	}
+
+	public int getSlotStackLimit() {
+		return this.inventory.getInventoryStackLimit();
+	}
+
+	public int getBackgroundIconIndex() {
+		return -1;
+	}
+
+	public ItemStack decrStackSize(int var1) {
+		return this.inventory.decrStackSize(this.slotIndex, var1);
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet27Position.java
@@ -1,0 +1,40 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet27Position extends Packet {
+	private float field_22039_a;
+	private float field_22038_b;
+	private boolean field_22043_c;
+	private boolean field_22042_d;
+	private float field_22041_e;
+	private float field_22040_f;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_22039_a = var1.readFloat();
+		this.field_22038_b = var1.readFloat();
+		this.field_22041_e = var1.readFloat();
+		this.field_22040_f = var1.readFloat();
+		this.field_22043_c = var1.readBoolean();
+		this.field_22042_d = var1.readBoolean();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeFloat(this.field_22039_a);
+		var1.writeFloat(this.field_22038_b);
+		var1.writeFloat(this.field_22041_e);
+		var1.writeFloat(this.field_22040_f);
+		var1.writeBoolean(this.field_22043_c);
+		var1.writeBoolean(this.field_22042_d);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_22185_a(this);
+	}
+
+	public int getPacketSize() {
+		return 18;
+	}
+}
--- net/minecraft/src/BlockFurnace.java
+++ net/minecraft/src/BlockFurnace.java
@@ -86,6 +86,9 @@
 	}
 
 	public boolean blockActivated(World var1, int var2, int var3, int var4, EntityPlayer var5) {
+		if(var1.multiplayerWorld) {
+			return true;
+		}
 		TileEntityFurnace var6 = (TileEntityFurnace)var1.getBlockTileEntity(var2, var3, var4);
 		var5.displayGUIFurnace(var6);
 		return true;
--- /dev/null
+++ net/minecraft/src/ShapelessRecipes.java
@@ -1,0 +1,56 @@
+package net.minecraft.src;
+
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
+public class ShapelessRecipes implements IRecipe {
+	private final ItemStack recipeOutput;
+	private final List recipeItems;
+
+	public ShapelessRecipes(ItemStack var1, List var2) {
+		this.recipeOutput = var1;
+		this.recipeItems = var2;
+	}
+
+	public ItemStack getRecipeOutput() {
+		return this.recipeOutput;
+	}
+
+	public boolean matches(InventoryCrafting var1) {
+		ArrayList var2 = new ArrayList(this.recipeItems);
+
+		for(int var3 = 0; var3 < 3; ++var3) {
+			for(int var4 = 0; var4 < 3; ++var4) {
+				ItemStack var5 = var1.func_21103_b(var4, var3);
+				if(var5 != null) {
+					boolean var6 = false;
+					Iterator var7 = var2.iterator();
+
+					while(var7.hasNext()) {
+						ItemStack var8 = (ItemStack)var7.next();
+						if(var5.itemID == var8.itemID && (var8.getItemDamage() == -1 || var5.getItemDamage() == var8.getItemDamage())) {
+							var6 = true;
+							var2.remove(var8);
+							break;
+						}
+					}
+
+					if(!var6) {
+						return false;
+					}
+				}
+			}
+		}
+
+		return var2.isEmpty();
+	}
+
+	public ItemStack getCraftingResult(InventoryCrafting var1) {
+		return this.recipeOutput.copy();
+	}
+
+	public int getRecipeSize() {
+		return this.recipeItems.size();
+	}
+}
--- /dev/null
+++ net/minecraft/src/Container.java
@@ -1,0 +1,253 @@
+package net.minecraft.src;
+
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+public abstract class Container {
+	public List field_20123_d = new ArrayList();
+	public List slots = new ArrayList();
+	public int windowId = 0;
+	private short field_20917_a = 0;
+	protected List field_20121_g = new ArrayList();
+	private Set field_20918_b = new HashSet();
+
+	protected void addSlot(Slot var1) {
+		var1.slotNumber = this.slots.size();
+		this.slots.add(var1);
+		this.field_20123_d.add((Object)null);
+	}
+
+	public void updateCraftingResults() {
+		for(int var1 = 0; var1 < this.slots.size(); ++var1) {
+			ItemStack var2 = ((Slot)this.slots.get(var1)).getStack();
+			ItemStack var3 = (ItemStack)this.field_20123_d.get(var1);
+			if(!ItemStack.areItemStacksEqual(var3, var2)) {
+				var3 = var2 == null ? null : var2.copy();
+				this.field_20123_d.set(var1, var3);
+
+				for(int var4 = 0; var4 < this.field_20121_g.size(); ++var4) {
+					((ICrafting)this.field_20121_g.get(var4)).func_20159_a(this, var1, var3);
+				}
+			}
+		}
+
+	}
+
+	public Slot getSlot(int var1) {
+		return (Slot)this.slots.get(var1);
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		Slot var2 = (Slot)this.slots.get(var1);
+		return var2 != null ? var2.getStack() : null;
+	}
+
+	public ItemStack func_27280_a(int var1, int var2, boolean var3, EntityPlayer var4) {
+		ItemStack var5 = null;
+		if(var2 == 0 || var2 == 1) {
+			InventoryPlayer var6 = var4.inventory;
+			if(var1 == -999) {
+				if(var6.getItemStack() != null && var1 == -999) {
+					if(var2 == 0) {
+						var4.dropPlayerItem(var6.getItemStack());
+						var6.setItemStack((ItemStack)null);
+					}
+
+					if(var2 == 1) {
+						var4.dropPlayerItem(var6.getItemStack().splitStack(1));
+						if(var6.getItemStack().stackSize == 0) {
+							var6.setItemStack((ItemStack)null);
+						}
+					}
+				}
+			} else {
+				int var10;
+				if(var3) {
+					ItemStack var7 = this.getStackInSlot(var1);
+					if(var7 != null) {
+						int var8 = var7.stackSize;
+						var5 = var7.copy();
+						Slot var9 = (Slot)this.slots.get(var1);
+						if(var9 != null && var9.getStack() != null) {
+							var10 = var9.getStack().stackSize;
+							if(var10 < var8) {
+								this.func_27280_a(var1, var2, var3, var4);
+							}
+						}
+					}
+				} else {
+					Slot var12 = (Slot)this.slots.get(var1);
+					if(var12 != null) {
+						var12.onSlotChanged();
+						ItemStack var13 = var12.getStack();
+						ItemStack var14 = var6.getItemStack();
+						if(var13 != null) {
+							var5 = var13.copy();
+						}
+
+						if(var13 == null) {
+							if(var14 != null && var12.isItemValid(var14)) {
+								var10 = var2 == 0 ? var14.stackSize : 1;
+								if(var10 > var12.getSlotStackLimit()) {
+									var10 = var12.getSlotStackLimit();
+								}
+
+								var12.putStack(var14.splitStack(var10));
+								if(var14.stackSize == 0) {
+									var6.setItemStack((ItemStack)null);
+								}
+							}
+						} else if(var14 == null) {
+							var10 = var2 == 0 ? var13.stackSize : (var13.stackSize + 1) / 2;
+							ItemStack var11 = var12.decrStackSize(var10);
+							var6.setItemStack(var11);
+							if(var13.stackSize == 0) {
+								var12.putStack((ItemStack)null);
+							}
+
+							var12.onPickupFromSlot(var6.getItemStack());
+						} else if(var12.isItemValid(var14)) {
+							if(var13.itemID != var14.itemID || var13.getHasSubtypes() && var13.getItemDamage() != var14.getItemDamage()) {
+								if(var14.stackSize <= var12.getSlotStackLimit()) {
+									var12.putStack(var14);
+									var6.setItemStack(var13);
+								}
+							} else {
+								var10 = var2 == 0 ? var14.stackSize : 1;
+								if(var10 > var12.getSlotStackLimit() - var13.stackSize) {
+									var10 = var12.getSlotStackLimit() - var13.stackSize;
+								}
+
+								if(var10 > var14.getMaxStackSize() - var13.stackSize) {
+									var10 = var14.getMaxStackSize() - var13.stackSize;
+								}
+
+								var14.splitStack(var10);
+								if(var14.stackSize == 0) {
+									var6.setItemStack((ItemStack)null);
+								}
+
+								var13.stackSize += var10;
+							}
+						} else if(var13.itemID == var14.itemID && var14.getMaxStackSize() > 1 && (!var13.getHasSubtypes() || var13.getItemDamage() == var14.getItemDamage())) {
+							var10 = var13.stackSize;
+							if(var10 > 0 && var10 + var14.stackSize <= var14.getMaxStackSize()) {
+								var14.stackSize += var10;
+								var13.splitStack(var10);
+								if(var13.stackSize == 0) {
+									var12.putStack((ItemStack)null);
+								}
+
+								var12.onPickupFromSlot(var6.getItemStack());
+							}
+						}
+					}
+				}
+			}
+		}
+
+		return var5;
+	}
+
+	public void onCraftGuiClosed(EntityPlayer var1) {
+		InventoryPlayer var2 = var1.inventory;
+		if(var2.getItemStack() != null) {
+			var1.dropPlayerItem(var2.getItemStack());
+			var2.setItemStack((ItemStack)null);
+		}
+
+	}
+
+	public void onCraftMatrixChanged(IInventory var1) {
+		this.updateCraftingResults();
+	}
+
+	public void putStackInSlot(int var1, ItemStack var2) {
+		this.getSlot(var1).putStack(var2);
+	}
+
+	public void putStacksInSlots(ItemStack[] var1) {
+		for(int var2 = 0; var2 < var1.length; ++var2) {
+			this.getSlot(var2).putStack(var1[var2]);
+		}
+
+	}
+
+	public void func_20112_a(int var1, int var2) {
+	}
+
+	public short func_20111_a(InventoryPlayer var1) {
+		++this.field_20917_a;
+		return this.field_20917_a;
+	}
+
+	public void func_20113_a(short var1) {
+	}
+
+	public void func_20110_b(short var1) {
+	}
+
+	public abstract boolean isUsableByPlayer(EntityPlayer var1);
+
+	protected void func_28125_a(ItemStack var1, int var2, int var3, boolean var4) {
+		int var5 = var2;
+		if(var4) {
+			var5 = var3 - 1;
+		}
+
+		Slot var6;
+		ItemStack var7;
+		if(var1.isStackable()) {
+			while(var1.stackSize > 0 && (!var4 && var5 < var3 || var4 && var5 >= var2)) {
+				var6 = (Slot)this.slots.get(var5);
+				var7 = var6.getStack();
+				if(var7 != null && var7.itemID == var1.itemID && (!var1.getHasSubtypes() || var1.getItemDamage() == var7.getItemDamage())) {
+					int var8 = var7.stackSize + var1.stackSize;
+					if(var8 <= var1.getMaxStackSize()) {
+						var1.stackSize = 0;
+						var7.stackSize = var8;
+						var6.onSlotChanged();
+					} else if(var7.stackSize < var1.getMaxStackSize()) {
+						var1.stackSize -= var1.getMaxStackSize() - var7.stackSize;
+						var7.stackSize = var1.getMaxStackSize();
+						var6.onSlotChanged();
+					}
+				}
+
+				if(var4) {
+					--var5;
+				} else {
+					++var5;
+				}
+			}
+		}
+
+		if(var1.stackSize > 0) {
+			if(var4) {
+				var5 = var3 - 1;
+			} else {
+				var5 = var2;
+			}
+
+			while(!var4 && var5 < var3 || var4 && var5 >= var2) {
+				var6 = (Slot)this.slots.get(var5);
+				var7 = var6.getStack();
+				if(var7 == null) {
+					var6.putStack(var1.copy());
+					var6.onSlotChanged();
+					var1.stackSize = 0;
+					break;
+				}
+
+				if(var4) {
+					--var5;
+				} else {
+					++var5;
+				}
+			}
+		}
+
+	}
+}
--- net/minecraft/src/Packet22Collect.java
+++ net/minecraft/src/Packet22Collect.java
@@ -13,7 +13,7 @@
 		this.collectorEntityId = var1.readInt();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.collectedEntityId);
 		var1.writeInt(this.collectorEntityId);
 	}
--- net/minecraft/src/SlotCrafting.java
+++ net/minecraft/src/SlotCrafting.java
@@ -1,10 +1,12 @@
 package net.minecraft.src;
 
-public class SlotCrafting extends SlotInventory {
+public class SlotCrafting extends Slot {
 	private final IInventory craftMatrix;
+	private EntityPlayer thePlayer;
 
-	public SlotCrafting(GuiContainer var1, IInventory var2, IInventory var3, int var4, int var5, int var6) {
-		super(var1, var3, var4, var5, var6);
+	public SlotCrafting(EntityPlayer var1, IInventory var2, IInventory var3, int var4, int var5, int var6) {
+		super(var3, var4, var5, var6);
+		this.thePlayer = var1;
 		this.craftMatrix = var2;
 	}
 
@@ -12,10 +14,16 @@
 		return false;
 	}
 
-	public void onPickupFromSlot() {
-		for(int var1 = 0; var1 < this.craftMatrix.getSizeInventory(); ++var1) {
-			if(this.craftMatrix.getStackInSlot(var1) != null) {
-				this.craftMatrix.decrStackSize(var1, 1);
+	public void onPickupFromSlot(ItemStack var1) {
+		var1.onCrafting(this.thePlayer.worldObj, this.thePlayer);
+
+		for(int var2 = 0; var2 < this.craftMatrix.getSizeInventory(); ++var2) {
+			ItemStack var3 = this.craftMatrix.getStackInSlot(var2);
+			if(var3 != null) {
+				this.craftMatrix.decrStackSize(var2, 1);
+				if(var3.getItem().hasContainerItem()) {
+					this.craftMatrix.setInventorySlotContents(var2, new ItemStack(var3.getItem().getContainerItem()));
+				}
 			}
 		}
 
--- net/minecraft/src/GuiFurnace.java
+++ net/minecraft/src/GuiFurnace.java
@@ -6,21 +6,8 @@
 	private TileEntityFurnace furnaceInventory;
 
 	public GuiFurnace(InventoryPlayer var1, TileEntityFurnace var2) {
+		super(new ContainerFurnace(var1, var2));
 		this.furnaceInventory = var2;
-		this.inventorySlots.add(new SlotInventory(this, var2, 0, 56, 17));
-		this.inventorySlots.add(new SlotInventory(this, var2, 1, 56, 53));
-		this.inventorySlots.add(new SlotInventory(this, var2, 2, 116, 35));
-
-		int var3;
-		for(var3 = 0; var3 < 3; ++var3) {
-			for(int var4 = 0; var4 < 9; ++var4) {
-				this.inventorySlots.add(new SlotInventory(this, var1, var4 + (var3 + 1) * 9, 8 + var4 * 18, 84 + var3 * 18));
-			}
-		}
-
-		for(var3 = 0; var3 < 9; ++var3) {
-			this.inventorySlots.add(new SlotInventory(this, var1, var3, 8 + var3 * 18, 142));
-		}
 
 	}
 
